/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { MedialiveChannelInputAttachmentsInputSettingsAudioSelector, MedialiveChannelInputAttachmentsInputSettingsAudioSelectorList, MedialiveChannelInputAttachmentsInputSettingsCaptionSelector, MedialiveChannelInputAttachmentsInputSettingsCaptionSelectorList, MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettings, MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettingsOutputReference, MedialiveChannelInputAttachmentsAutomaticInputFailoverSettings, MedialiveChannelInputAttachmentsAutomaticInputFailoverSettingsOutputReference } from './structs0';
export interface MedialiveChannelInputAttachmentsInputSettingsVideoSelector {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#color_space MedialiveChannel#color_space}
    */
    readonly colorSpace?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#color_space_usage MedialiveChannel#color_space_usage}
    */
    readonly colorSpaceUsage?: string;
}
export declare function medialiveChannelInputAttachmentsInputSettingsVideoSelectorToTerraform(struct?: MedialiveChannelInputAttachmentsInputSettingsVideoSelectorOutputReference | MedialiveChannelInputAttachmentsInputSettingsVideoSelector): any;
export declare class MedialiveChannelInputAttachmentsInputSettingsVideoSelectorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelInputAttachmentsInputSettingsVideoSelector | undefined;
    set internalValue(value: MedialiveChannelInputAttachmentsInputSettingsVideoSelector | undefined);
    private _colorSpace?;
    get colorSpace(): string;
    set colorSpace(value: string);
    resetColorSpace(): void;
    get colorSpaceInput(): string | undefined;
    private _colorSpaceUsage?;
    get colorSpaceUsage(): string;
    set colorSpaceUsage(value: string);
    resetColorSpaceUsage(): void;
    get colorSpaceUsageInput(): string | undefined;
}
export interface MedialiveChannelInputAttachmentsInputSettings {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#deblock_filter MedialiveChannel#deblock_filter}
    */
    readonly deblockFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#denoise_filter MedialiveChannel#denoise_filter}
    */
    readonly denoiseFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#filter_strength MedialiveChannel#filter_strength}
    */
    readonly filterStrength?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#input_filter MedialiveChannel#input_filter}
    */
    readonly inputFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#scte35_pid MedialiveChannel#scte35_pid}
    */
    readonly scte35Pid?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#smpte2038_data_preference MedialiveChannel#smpte2038_data_preference}
    */
    readonly smpte2038DataPreference?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#source_end_behavior MedialiveChannel#source_end_behavior}
    */
    readonly sourceEndBehavior?: string;
    /**
    * audio_selector block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#audio_selector MedialiveChannel#audio_selector}
    */
    readonly audioSelector?: MedialiveChannelInputAttachmentsInputSettingsAudioSelector[] | cdktf.IResolvable;
    /**
    * caption_selector block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#caption_selector MedialiveChannel#caption_selector}
    */
    readonly captionSelector?: MedialiveChannelInputAttachmentsInputSettingsCaptionSelector[] | cdktf.IResolvable;
    /**
    * network_input_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#network_input_settings MedialiveChannel#network_input_settings}
    */
    readonly networkInputSettings?: MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettings;
    /**
    * video_selector block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#video_selector MedialiveChannel#video_selector}
    */
    readonly videoSelector?: MedialiveChannelInputAttachmentsInputSettingsVideoSelector;
}
export declare function medialiveChannelInputAttachmentsInputSettingsToTerraform(struct?: MedialiveChannelInputAttachmentsInputSettingsOutputReference | MedialiveChannelInputAttachmentsInputSettings): any;
export declare class MedialiveChannelInputAttachmentsInputSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelInputAttachmentsInputSettings | undefined;
    set internalValue(value: MedialiveChannelInputAttachmentsInputSettings | undefined);
    private _deblockFilter?;
    get deblockFilter(): string;
    set deblockFilter(value: string);
    resetDeblockFilter(): void;
    get deblockFilterInput(): string | undefined;
    private _denoiseFilter?;
    get denoiseFilter(): string;
    set denoiseFilter(value: string);
    resetDenoiseFilter(): void;
    get denoiseFilterInput(): string | undefined;
    private _filterStrength?;
    get filterStrength(): number;
    set filterStrength(value: number);
    resetFilterStrength(): void;
    get filterStrengthInput(): number | undefined;
    private _inputFilter?;
    get inputFilter(): string;
    set inputFilter(value: string);
    resetInputFilter(): void;
    get inputFilterInput(): string | undefined;
    private _scte35Pid?;
    get scte35Pid(): number;
    set scte35Pid(value: number);
    resetScte35Pid(): void;
    get scte35PidInput(): number | undefined;
    private _smpte2038DataPreference?;
    get smpte2038DataPreference(): string;
    set smpte2038DataPreference(value: string);
    resetSmpte2038DataPreference(): void;
    get smpte2038DataPreferenceInput(): string | undefined;
    private _sourceEndBehavior?;
    get sourceEndBehavior(): string;
    set sourceEndBehavior(value: string);
    resetSourceEndBehavior(): void;
    get sourceEndBehaviorInput(): string | undefined;
    private _audioSelector;
    get audioSelector(): MedialiveChannelInputAttachmentsInputSettingsAudioSelectorList;
    putAudioSelector(value: MedialiveChannelInputAttachmentsInputSettingsAudioSelector[] | cdktf.IResolvable): void;
    resetAudioSelector(): void;
    get audioSelectorInput(): cdktf.IResolvable | MedialiveChannelInputAttachmentsInputSettingsAudioSelector[] | undefined;
    private _captionSelector;
    get captionSelector(): MedialiveChannelInputAttachmentsInputSettingsCaptionSelectorList;
    putCaptionSelector(value: MedialiveChannelInputAttachmentsInputSettingsCaptionSelector[] | cdktf.IResolvable): void;
    resetCaptionSelector(): void;
    get captionSelectorInput(): cdktf.IResolvable | MedialiveChannelInputAttachmentsInputSettingsCaptionSelector[] | undefined;
    private _networkInputSettings;
    get networkInputSettings(): MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettingsOutputReference;
    putNetworkInputSettings(value: MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettings): void;
    resetNetworkInputSettings(): void;
    get networkInputSettingsInput(): MedialiveChannelInputAttachmentsInputSettingsNetworkInputSettings | undefined;
    private _videoSelector;
    get videoSelector(): MedialiveChannelInputAttachmentsInputSettingsVideoSelectorOutputReference;
    putVideoSelector(value: MedialiveChannelInputAttachmentsInputSettingsVideoSelector): void;
    resetVideoSelector(): void;
    get videoSelectorInput(): MedialiveChannelInputAttachmentsInputSettingsVideoSelector | undefined;
}
export interface MedialiveChannelInputAttachments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#input_attachment_name MedialiveChannel#input_attachment_name}
    */
    readonly inputAttachmentName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#input_id MedialiveChannel#input_id}
    */
    readonly inputId: string;
    /**
    * automatic_input_failover_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#automatic_input_failover_settings MedialiveChannel#automatic_input_failover_settings}
    */
    readonly automaticInputFailoverSettings?: MedialiveChannelInputAttachmentsAutomaticInputFailoverSettings;
    /**
    * input_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#input_settings MedialiveChannel#input_settings}
    */
    readonly inputSettings?: MedialiveChannelInputAttachmentsInputSettings;
}
export declare function medialiveChannelInputAttachmentsToTerraform(struct?: MedialiveChannelInputAttachments | cdktf.IResolvable): any;
export declare class MedialiveChannelInputAttachmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MedialiveChannelInputAttachments | cdktf.IResolvable | undefined;
    set internalValue(value: MedialiveChannelInputAttachments | cdktf.IResolvable | undefined);
    private _inputAttachmentName?;
    get inputAttachmentName(): string;
    set inputAttachmentName(value: string);
    get inputAttachmentNameInput(): string | undefined;
    private _inputId?;
    get inputId(): string;
    set inputId(value: string);
    get inputIdInput(): string | undefined;
    private _automaticInputFailoverSettings;
    get automaticInputFailoverSettings(): MedialiveChannelInputAttachmentsAutomaticInputFailoverSettingsOutputReference;
    putAutomaticInputFailoverSettings(value: MedialiveChannelInputAttachmentsAutomaticInputFailoverSettings): void;
    resetAutomaticInputFailoverSettings(): void;
    get automaticInputFailoverSettingsInput(): MedialiveChannelInputAttachmentsAutomaticInputFailoverSettings | undefined;
    private _inputSettings;
    get inputSettings(): MedialiveChannelInputAttachmentsInputSettingsOutputReference;
    putInputSettings(value: MedialiveChannelInputAttachmentsInputSettings): void;
    resetInputSettings(): void;
    get inputSettingsInput(): MedialiveChannelInputAttachmentsInputSettings | undefined;
}
export declare class MedialiveChannelInputAttachmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MedialiveChannelInputAttachments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MedialiveChannelInputAttachmentsOutputReference;
}
export interface MedialiveChannelInputSpecification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#codec MedialiveChannel#codec}
    */
    readonly codec: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#input_resolution MedialiveChannel#input_resolution}
    */
    readonly inputResolution: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#maximum_bitrate MedialiveChannel#maximum_bitrate}
    */
    readonly maximumBitrate: string;
}
export declare function medialiveChannelInputSpecificationToTerraform(struct?: MedialiveChannelInputSpecificationOutputReference | MedialiveChannelInputSpecification): any;
export declare class MedialiveChannelInputSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelInputSpecification | undefined;
    set internalValue(value: MedialiveChannelInputSpecification | undefined);
    private _codec?;
    get codec(): string;
    set codec(value: string);
    get codecInput(): string | undefined;
    private _inputResolution?;
    get inputResolution(): string;
    set inputResolution(value: string);
    get inputResolutionInput(): string | undefined;
    private _maximumBitrate?;
    get maximumBitrate(): string;
    set maximumBitrate(value: string);
    get maximumBitrateInput(): string | undefined;
}
export interface MedialiveChannelMaintenance {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#maintenance_day MedialiveChannel#maintenance_day}
    */
    readonly maintenanceDay: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#maintenance_start_time MedialiveChannel#maintenance_start_time}
    */
    readonly maintenanceStartTime: string;
}
export declare function medialiveChannelMaintenanceToTerraform(struct?: MedialiveChannelMaintenanceOutputReference | MedialiveChannelMaintenance): any;
export declare class MedialiveChannelMaintenanceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelMaintenance | undefined;
    set internalValue(value: MedialiveChannelMaintenance | undefined);
    private _maintenanceDay?;
    get maintenanceDay(): string;
    set maintenanceDay(value: string);
    get maintenanceDayInput(): string | undefined;
    private _maintenanceStartTime?;
    get maintenanceStartTime(): string;
    set maintenanceStartTime(value: string);
    get maintenanceStartTimeInput(): string | undefined;
}
export interface MedialiveChannelTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#create MedialiveChannel#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#delete MedialiveChannel#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#update MedialiveChannel#update}
    */
    readonly update?: string;
}
export declare function medialiveChannelTimeoutsToTerraform(struct?: MedialiveChannelTimeouts | cdktf.IResolvable): any;
export declare class MedialiveChannelTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MedialiveChannelTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface MedialiveChannelVpc {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#public_address_allocation_ids MedialiveChannel#public_address_allocation_ids}
    */
    readonly publicAddressAllocationIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#security_group_ids MedialiveChannel#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.8.0/docs/resources/medialive_channel#subnet_ids MedialiveChannel#subnet_ids}
    */
    readonly subnetIds: string[];
}
export declare function medialiveChannelVpcToTerraform(struct?: MedialiveChannelVpcOutputReference | MedialiveChannelVpc): any;
export declare class MedialiveChannelVpcOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MedialiveChannelVpc | undefined;
    set internalValue(value: MedialiveChannelVpc | undefined);
    get availabilityZones(): string[];
    private _publicAddressAllocationIds?;
    get publicAddressAllocationIds(): string[];
    set publicAddressAllocationIds(value: string[]);
    get publicAddressAllocationIdsInput(): string[] | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    get subnetIds(): string[];
    set subnetIds(value: string[]);
    get subnetIdsInput(): string[] | undefined;
}
